<?php
/**
 * LessPHP
 *
 * Plugin Copyright 2012 Peter Edley<peter@cww.org.uk>
 *
 * LessPHP class Copyright © 2010 Leaf Corcoran, http://leafo.net/lessphp
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 * THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * @author Peter Edley<peter@cww.org.uk>
 * @version Version 1.0.0
 *
 * 31/3/12
 *
 * lessphp is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option) any
 * later version.
 *
 * lessphp is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * lessphp; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * @package lessphp
 */

/**
 * MODx lessphp plugin
 *
 * Description: Compiles a .less file on initial page load or when file changes and places the compiled css into /assests/css/
 * it then adds the required stylesheet link to the head of each page. * Events: OnLoadWebDocument
 *
 * @package lessphp
 */

require MODX_CORE_PATH . 'components/lessphp/model/lessphp/less.inc.php';

function auto_compile_less($less_fname, $css_fname) {
    // load the cache
    $cache_fname = $less_fname.".cache";
    if (file_exists($cache_fname)) {
        $cache = unserialize(file_get_contents($cache_fname));
    } else {
        if ( !(file_exists($less_fname) and is_file($less_fname)) ) {
            return false;
        }
        $cache = $less_fname;
    }

    $new_cache = lessc::cexecute($cache);
    if (!is_array($cache) || $new_cache['updated'] > $cache['updated']) {
        file_put_contents($cache_fname, serialize($new_cache));
        file_put_contents($css_fname, $new_cache['compiled']);
    }
    return true;
}

$lessfile = $modx->getOption('lessphp_filename');
$less_file = MODX_BASE_PATH.$lessfile;
$css_file = MODX_BASE_PATH.'assets/css/main.css';
if (auto_compile_less($less_file, $css_file)) {
    $modx->regClientCSS('assets/css/main.css');
}


